#pragma once

#include "moveableentity.h"

namespace MetaData
{
    struct Player;
    struct Equip;
    struct EquipUpgrade;
}

class Human;
class Obstacle;
class CircleCollider;
class MovementComponent;
class Bullet : public MoveableEntity
{
 public:
    int gun_lv = 0;
    MetaData::Equip* gun_meta = nullptr;
    MetaData::EquipUpgrade* gun_upgrade_meta = nullptr;
    MetaData::Equip* meta = nullptr;
    Human* player = nullptr;
    a8::Vec2 dir;
    a8::Vec2 born_pos;
    a8::Vec2 born_dir;
    float fly_distance = 0.0f;
    bool is_tank_skin = false;
    MovementComponent* movement = nullptr;

    virtual ~Bullet() override;
    virtual void Initialize() override;
    virtual void Update(int delta_time) override;
    void RecalcSelfCollider();

protected:
    Bullet();

 private:

    void OnHit(std::set<Entity*>& objects);
    void ProcBomb();
    bool IsBomb();
    inline void MapServiceUpdate();
    float GetAtk();
    void Check(float distance);

private:
    CircleCollider* self_collider_ = nullptr;
    bool later_removed_ = false;

    friend class EntityFactory;
};
