#pragma once

#include "entity.h"

namespace MetaData
{
    struct MapThing;
    struct Building;
}

namespace metatable
{
    class DoorObjJson;
}

class Room;
class Human;
class Building;
class CircleCollider;
class AabbCollider;
class Bullet;
class Obstacle : public Entity
{
 public:
    MetaData::MapThing* meta = nullptr;
    MapService* permanent_map_service = nullptr;
    bool is_permanent = false;

    virtual ~Obstacle() override;
    virtual void Initialize() override;
    virtual void RecalcSelfCollider();
    virtual void FillMFObjectPart(Room* room, Human* hum, cs::MFObjectPart* part_data) override;
    virtual void FillMFObjectFull(Room* room, Human* hum, cs::MFObjectFull* full_data) override;
    virtual void GetAabbBox(AabbCollider& aabb_box) override;
    virtual void GetCircleBox(CircleCollider& circle_box) override;
    virtual bool IsDead(Room* room) override;
    virtual long long GetDeadFrameNo(Room* room) override;
    virtual void OnPreCollision(Room* room) override;
    virtual bool IsTerminatorAirDropBox(Room* room) { return false; }
    void Explosion(Bullet* bullet);
    void SetDoorInfo(Building* building, int door_id_x);
    bool IsDoor();
    DoorState_e GetDoorState(Room* room);
    void SetDoorState(Room* room, DoorState_e state);
    void SetBuilding(Building* building);
    Building* GetBuilding();
    const metatable::DoorObjJson* GetDoorState0();
    const metatable::DoorObjJson* GetDoorState1();
    void IncDoorOpenTimes(Room* room);
    float GetHealth(Room* room);
    void SetHealth(Room* room, float value);
    void Die(Room* room);
    bool IsPermanent();
    bool Attackable();
    bool Throughable();

protected:
    Obstacle();

protected:
    CircleCollider* self_collider_ = nullptr;
    AabbCollider* self_collider2_ = nullptr;

    bool is_door_ = false;
    int door_id_ = 0;
    const metatable::DoorObjJson* door_state0_ = nullptr;
    const metatable::DoorObjJson* door_state1_ = nullptr;
    int door_house_uniid_ = 0;
    Building* building_ = nullptr;

    float health_ = 0.0f;
    bool dead_ = false;
    long long dead_frameno_ = 0;

    friend class EntityFactory;
};
