#include "precompile.h"

#include "metamgr.h"
#include "room.h"
#include "collider.h"
#include "building.h"
#include "human.h"
#include "app.h"
#include "typeconvert.h"
#include "bullet.h"
#include "mapservice.h"
#include "roomobstacle.h"

RoomObstacle::RoomObstacle():Obstacle()
{
}

RoomObstacle::~RoomObstacle()
{
    for (auto& itr : colliders_) {
        ColliderComponent* collider = itr;
#ifdef DEBUG
        #if 0
        a8::UdpLog::Instance()->Debug("OnRemoveCollider %d %d %d",
                                      {
                                       room->GetRoomIdx(),
                                       GetEntityUniId(),
                                       (long long)collider
                                      });
        #endif
#endif
        room->map_service->RemoveCollider(collider);
    }
}

void RoomObstacle::Initialize()
{
    Obstacle::Initialize();
    xtimer_attacher.xtimer = &room->xtimer;
}

void RoomObstacle::RecalcSelfCollider()
{
    if (!Throughable()){
        switch (meta->i->type()) {
        case 1:
            {
                if (!self_collider_) {
                    self_collider_ = new CircleCollider();
                    self_collider_->owner = this;
                    AddEntityCollider(self_collider_);
                }
                self_collider_->pos = a8::Vec2();
                self_collider_->rad = meta->i->height() / 2.0;
                room->map_service->AddCollider(self_collider_);
            }
            break;
        case 2:
            {
                if (!self_collider2_) {
                    self_collider2_ = new AabbCollider();
                    self_collider2_->owner = this;
                    AddEntityCollider(self_collider2_);
                }
                self_collider2_->_min = a8::Vec2(meta->i->width() / -2.0f, meta->i->height() / -2.0f);
                self_collider2_->_max = a8::Vec2(meta->i->width() / 2.0f, meta->i->height() / 2.0f);
                room->map_service->AddCollider(self_collider2_);
            }
            break;
        }
    }
    if (!self_collider_) {
    #ifdef DEBUG
#if 0
    a8::UdpLog::Instance()->Debug("OnAddCollider %d %d %d",
                                  {
                                   room->GetRoomIdx(),
                                   GetEntityUniId(),
                                   (long long)self_collider_
                                  });
#endif
    #endif
    }
}
