#pragma once

namespace a8
{
    class MutableXObject;
}

class VirtualClient;
class VirtualClientMgr : public a8::Singleton<VirtualClientMgr>
{

 private:
    VirtualClientMgr() {};
    friend class a8::Singleton<VirtualClientMgr>;

 public:

    void Init();
    void UnInit();
    void Update();

    VirtualClient* GetVirtualClientByAccount(const std::string& account);
    VirtualClient* GetVirtualClientByInstanceId(int instance_id);

 private:
    std::map<std::string, VirtualClient*> account_hash_;
    std::map<int, VirtualClient*> instanceid_hash_;

};
